#ifndef INTERACTABLEWALLOBJECT_HPP_INCLUDED
#define INTERACTABLEWALLOBJECT_HPP_INCLUDED

#include "../../Core/Classes/WallObject.hpp"
#include "../../Core/Classes/ObjectInfo.hpp"
#include "../../Core/Types/Tile.hpp"
#include "../../Core/Types/Point.hpp"
#include "../../Core/Types/Box.hpp"
#include "../../Core/Types/Convex.hpp"
#include "../../Core/Input.hpp"
#include <cstdint>

namespace Interactable
{
    class WallObject : public Internal::WallObject
    {
        public:
            WallObject(const Internal::WallObject& W);
            WallObject(const WallObject& W);

            std::int32_t GetID() const;
            std::string GetName() const;
            Internal::ObjectInfo GetInfo() const;

            Box GetBox() const;
            Point GetPoint() const;
            Convex GetConvex() const;
            std::vector<Point> GetModel() const;

            double GetVisibility() const;
            Tile GetTile() const;

            bool Interact(const Button& B = BUTTON_LEFT) const;
            bool Interact(const std::string& Option) const;
            bool Interact(const std::vector<std::string>& Options, bool RequireAllOptions = false) const;

            operator Internal::WallObject() const;
    };
}


#endif // INTERACTABLEWALLOBJECT_HPP_INCLUDED
