#ifndef DECORATIVEOBJECTS_HPP_INCLUDED
#define DECORATIVEOBJECTS_HPP_INCLUDED

#include "../../Game/Interactable/DecorativeObject.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>

/** @addtogroup Models
* @{ */
class DecorativeObjects
{
    public:

        static std::vector<Interactable::DecorativeObject> GetAll();
        static std::vector<Interactable::DecorativeObject> GetAll(std::int32_t ID);
        static std::vector<Interactable::DecorativeObject> GetAll(const std::string& Name);
        static std::vector<Interactable::DecorativeObject> GetAll(const std::vector<std::int32_t>& IDs);
        static std::vector<Interactable::DecorativeObject> GetAll(const std::vector<std::string>& Names);
        static std::vector<Interactable::DecorativeObject> GetAll(const std::function<bool (const Interactable::DecorativeObject&)>& Filter);

        static Interactable::DecorativeObject Get();
        static Interactable::DecorativeObject Get(const Tile& T);
        static Interactable::DecorativeObject Get(std::int32_t ID);
        static Interactable::DecorativeObject Get(const std::string& Name);
        static Interactable::DecorativeObject Get(const std::vector<std::int32_t>& IDs);
        static Interactable::DecorativeObject Get(const std::vector<std::string>& Names);
        static Interactable::DecorativeObject Get(const std::function<bool (const Interactable::DecorativeObject&)>& Filter);
};

/** @} */

#endif // DECORATIVEOBJECTS_HPP_INCLUDED
