#ifndef NPCS_HPP_INCLUDED
#define NPCS_HPP_INCLUDED

#include "../../Game/Interactable/NPC.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>


/** @addtogroup Models
* @{ */
class NPCs
{
    public:

        static std::vector<Interactable::NPC> GetAll();
        static std::vector<Interactable::NPC> GetAll(const Tile& Tile);
        static std::vector<Interactable::NPC> GetAll(std::int32_t ID);
        static std::vector<Interactable::NPC> GetAll(const std::string& Name);
        static std::vector<Interactable::NPC> GetAll(const std::vector<std::int32_t>& IDs);
        static std::vector<Interactable::NPC> GetAll(const std::vector<std::string>& Names);
        static std::vector<Interactable::NPC> GetAll(const std::function<bool (Interactable::NPC&)>& Filter);

        static Interactable::NPC Get();
        static Interactable::NPC Get(const Tile& Tile);
        static Interactable::NPC Get(std::int32_t ID);
        static Interactable::NPC Get(const std::string& Name);
        static Interactable::NPC Get(const std::vector<std::int32_t>& IDs);
        static Interactable::NPC Get(const std::vector<std::string>& Names);
        static Interactable::NPC Get(const std::function<bool (Interactable::NPC&)>& Filter);
};
/** @} */

#endif // NPCS_HPP_INCLUDED
